clc 
echo off
% Program untuk menghitung ekspansi fraksi parsial dan tanggapan undak sistem waktu diskrit
% Fungsi alih sistem tersebut diberikan oleh :
%           1                 1
% G(s) =  -----   ;   R(s) = --- 
%         s + 1               s
% R(s) adalah masukan tangga satuan
% Kemudian keluarannya dituliskan sebagai:
%                     1              
% C(s)= G(s) R(s) = ------ 
%                   s(s+1)   
% Untuk mendapatkan ekspansi parsialnya,maka dijalankan instruksi:
num1 =[0 1];
den1 =[1 1];
num2 =[0 1];
den2 =[1 0];
nums =conv (num1,num2);
dens =conv (den1,den2);
disp('Fungsi Alih Kontinu: ')
printsys(num1,den1)
CTF=tf(num1,den1);
disp(' ')
disp('Ekspansi Fraksi Parsial keluarannya: ')
[r,p,k]=residue (nums,dens)
Catatan = char('-Pembilang Fungsi Alih Kontinu = num')
disp('-Penyebut Fungsi Alih Kontinu = den')
disp(' ')
disp('Press any key to continue...')
pause
disp('Perhitungan Fungsi Alih,Ekspansi Fraksi Parsial,Tanggapan Undak Sistem Waktu Diskrit') 
% Fungsi alih sistem diskrit hendak diperoleh dari fungsi alih kontinu :
%            1
% G(s) =  -------
%          s + 1
% Kemudian keluarannya dituliskan sebagai:
%                     1
% C(s)= G(s) R(s) = ------
%                   s(s+1) 
% Fungsi alih sistem diskrit yang hendak diperoleh :
%          
%          0.63212
% G(z) = -----------
%        z - 0.36788
%          
% Kemudian keluarannya dituliskan sebagai:
%                        
%                  [   0.63212   ] [  z  ]
% C(z)= G(z) R(z) =[ ------------] [-----]
%                  [ z - 0.36788 ] [ z-1 ]
%        
% Untuk mendapatkan ekspansi parsialnya,maka dijalankan instruksi:
% Masukkan periode pencuplikan :
Ts=1;
% Selanjutnya masukkan pembilang dan penyebut dari masukan tangga satuan
num3=[1  0];
den3=[1 -1];
% Selanjutnya konversi dari sistem kontinu ke diskrit dengan menjalankan instruksi : 
[numd,dend]=c2dm(num1,den1,Ts,'zoh')
numz=conv (numd,num3);
denz=conv (dend,den3);
disp(' ')
disp(' Fungsi Alih Diskrit diperoleh yaitu : ')
printsys(numd,dend,'z')
disp('Ekspansi Fraksi Parsial keluaran Sistem Diskrit : ')
 [r p k]=residuez (numz,denz)
% Untuk mendapatkan plot tanggapan undak sistem jalankan instruksi:
DTF=tf(numd,dend,Ts);
disp(' ')
disp('Perbandingan Tanggapan Undak Sistem Kontinu dan Sistem Diskrit ------->')
step(CTF,'r',DTF,'--')
grid on
Catatan = char('-Pembilang Fungsi Alih Diskrit = num')
disp('-Penyebut Fungsi Alih Diskrit = den')
disp(' ')
disp('-Garis merah = Tanggapan Undak Sistem Kontinu')
disp(' ')
disp('-Garis biru putus-putus = Tanggapan Undak Sistem Diskrit')
